/**************************************************************************

	WWWC (SortItem.dll)

	main.c

	(C) Copyright 1996-2001 By Tomoaki Nakashima. All right reserved.
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/


/**************************************************************************
	Include Files
**************************************************************************/

#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE
#include <commctrl.h>

#include "wwwcdll.h"
#include "resource.h"


/**************************************************************************
	Define
**************************************************************************/

#define BUF_SIZE			256			/* obt@TCY */


/**************************************************************************
	Global Variables
**************************************************************************/

static HINSTANCE g_hinst;

static HWND WWWCWnd = NULL;

//tH_
struct TPTREE{
	int CheckFlag;										//`FbNtO
	int MemFlag;										//h~JE^
	int Icon;											//ԃACR
	int Expand;

	int CheckSt;										//`FbN^Ȃ
	int AutoCheckSt;									//ftHg̃`FbNgp^Ȃ
	int CheckMax;										//tH_`FbN

	char *Comment;										//Rg

	long *tpCheckTime;									//`FbNݒ
	int tpCheckTimeCnt;
	struct TPITEM **ItemList;							//ACeXg
	int ItemListCnt;
};


/******************************************************************************

	DllMain

	C

******************************************************************************/

int WINAPI DllMain(HINSTANCE hInst, DWORD fdwReason, PVOID pvReserved)
{
	g_hinst = hInst;

    switch(fdwReason)
    {
    case DLL_PROCESS_ATTACH:
		break;

    case DLL_PROCESS_DETACH:
    case DLL_THREAD_ATTACH:
    case DLL_THREAD_DETACH:
        break;
    }
    return TRUE;
}


/******************************************************************************

	GetToolList

	c[ݒ

******************************************************************************/

__declspec(dllexport) int CALLBACK GetToolList(int cnt, struct TP_TOOLS *tpToolInfo)
{
	int ret = 0;

	switch(cnt)
	{
	case 0:
		lstrcpy(tpToolInfo->title,"ACe̕בւ(&S)");
		tpToolInfo->Action = TOOL_EXEC_WINDOWMENU;
		lstrcpy(tpToolInfo->func,"SortItem");
		lstrcpy(tpToolInfo->Protocol,"");
		tpToolInfo->MenuIndex = 0;
		break;

	default:
		ret = -1;
		break;
	}
	return ret;
}


/******************************************************************************

	TreeView_GetlParam

	ACeɊ֘Atꂽ̎擾

******************************************************************************/

void *TreeView_GetlParam(HWND hTreeView, HTREEITEM hItem)
{
	TV_ITEM tvit;

	if(hItem == NULL){
		return NULL;
	}
	tvit.mask = TVIF_PARAM;
	tvit.hItem = hItem;
	tvit.lParam = 0;

	if(TreeView_GetItem(hTreeView, &tvit) == TRUE && tvit.lParam != 0){
		return (void *)tvit.lParam;
	}
	return NULL;
}


/******************************************************************************

	ListView_GetlParam

	ACeLPARAM擾

******************************************************************************/

long ListView_GetlParam(HWND hListView, int i)
{
	LV_ITEM lvi;
	long j = 0;

	lvi.mask = LVIF_PARAM;
	lvi.iItem = i;
	lvi.iSubItem = 0;
	lvi.lParam = j;
	ListView_GetItem(hListView, &lvi);
	return lvi.lParam;
}


/******************************************************************************

	ListView_SetlParam

	ACeLPARAMݒ

******************************************************************************/

void ListView_SetlParam(HWND hListView, int i, long lParam)
{
	LV_ITEM lvi;

	ZeroMemory(&lvi, sizeof(LVITEM));
	lvi.mask = LVIF_PARAM;
	lvi.iItem = i;
	lvi.iSubItem = 0;
	lvi.lParam = lParam;
	ListView_SetItem(hListView, &lvi);
}


/******************************************************************************

	SetListItem

	ListView ɃACeǉ

******************************************************************************/

static int SetListItem(HWND hListView, char *buf,int Img,long lp,int iItem)
{
	LV_ITEM LvItem;

	LvItem.mask = LVIF_TEXT | LVIF_PARAM;

	if(iItem == -1){
		iItem = ListView_GetItemCount(hListView);
	}
	LvItem.iItem = iItem;
	LvItem.iSubItem = 0;
	LvItem.pszText = buf;
	LvItem.cchTextMax = BUF_SIZE - 1;
	LvItem.iImage = Img;
	LvItem.lParam = lp;

	// Xgr[ɃACeǉ
	return ListView_InsertItem(hListView, &LvItem);
}


/******************************************************************************

	ListView_MoveItem

	Xgr[̃ACeړ

******************************************************************************/

void ListView_MoveItem(HWND hListView, int SelectItem, int Move, int ColSize)
{
#define MOVEITEM_MAX_COLSIZE	30
	LV_ITEM lvItem;
	char buf[MOVEITEM_MAX_COLSIZE][BUF_SIZE];
	long lParam;
	int i = 0;

	for(i = 0;i < ColSize;i++){
		*(buf[i]) = '\0';
	}

	lvItem.mask = LVIF_IMAGE;
	lvItem.iItem = SelectItem;
	lvItem.iSubItem = 0;
	lvItem.iImage = 0;
	if(ListView_GetItem(hListView, &lvItem) == FALSE){
		return;
	}
	for(i = 0;i < ColSize;i++){
		ListView_GetItemText(hListView, SelectItem, i, buf[i], BUF_SIZE - 1);
	}
	lParam = ListView_GetlParam(hListView, SelectItem);
	ListView_DeleteItem(hListView, SelectItem);

	SelectItem = SelectItem + Move;

	SetListItem(hListView, buf[0], lvItem.iImage, 0, SelectItem);
	for(i = 1;i < ColSize;i++){
		ListView_SetItemText(hListView, SelectItem, i, buf[i]);
	}
	ListView_SetlParam(hListView, SelectItem, lParam);
	ListView_SetItemState(hListView, SelectItem,
		LVIS_SELECTED | LVIS_FOCUSED, LVIS_SELECTED | LVIS_FOCUSED);
	ListView_EnsureVisible(hListView, SelectItem, TRUE);
}


/******************************************************************************

	ListView_SetListToMem

	Xgr[̃ACeACe쐬

******************************************************************************/

struct TPITEM **ListView_SetListToMem(HWND hListView, int *RetItemCnt)
{
	struct TPITEM **RetItemList;
	struct TPITEM *tpItemInfo;
	int ItemCnt, i, j;

	ItemCnt = ListView_GetItemCount(hListView);
	for(i = 0;i < ItemCnt;i++){
		tpItemInfo = (struct TPITEM *)ListView_GetlParam(hListView, i);
		if(tpItemInfo != NULL){
			break;
		}
	}
	RetItemList = (struct TPITEM **)GlobalAlloc(GPTR, sizeof(struct TPITEM *) * (ItemCnt - i));
	if(RetItemList == NULL){
		abort();
	}
	*RetItemCnt = ItemCnt - i;

	j = 0;
	for(;i < ItemCnt;i++){
		tpItemInfo = (struct TPITEM *)ListView_GetlParam(hListView, i);
		if(tpItemInfo == NULL){
			continue;
		}
		*(RetItemList + j) = tpItemInfo;
		j++;
	}
	return RetItemList;
}


/******************************************************************************

	DrawScrollControl

	XN[o[̃{^̕`

******************************************************************************/

void DrawScrollControl(LPDRAWITEMSTRUCT lpDrawItem, UINT i)
{
	#define FOCUSRECT_SIZE		3

	if(lpDrawItem->itemState & ODS_DISABLED){
		//gps\
		i |= DFCS_INACTIVE;
	}
	if(lpDrawItem->itemState & ODS_SELECTED){
		//I
		i |= DFCS_PUSHED;
	}

	//t[Rg[̕`
	DrawFrameControl(lpDrawItem->hDC, &(lpDrawItem->rcItem), DFC_SCROLL, i);

	//tH[JX
	if(lpDrawItem->itemState & ODS_FOCUS){
		lpDrawItem->rcItem.left += FOCUSRECT_SIZE;
		lpDrawItem->rcItem.top += FOCUSRECT_SIZE;
		lpDrawItem->rcItem.right -= FOCUSRECT_SIZE;
		lpDrawItem->rcItem.bottom -= FOCUSRECT_SIZE;
		DrawFocusRect(lpDrawItem->hDC, &(lpDrawItem->rcItem));
	}
}


/******************************************************************************

	ItemSortProc

	EBhEvV[W

******************************************************************************/

static BOOL CALLBACK ItemSortProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	struct TPTREE *tpTreeInfo;
	struct TPITEM *tpItemInfo;
	LV_COLUMN lvc;
	HWND hListView;
	char buf[BUF_SIZE];
	char *cmt;
	char *p, *r;
	int index;
	int cnt;
	int i, j;

	switch(uMsg)
	{
	case WM_INITDIALOG:
		i = 0;
		lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
		lvc.fmt = LVCFMT_LEFT;

		lvc.cx = 200;
		lvc.pszText = "O";
		lvc.iSubItem = i;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_ITEM), i, &lvc);

		i++;
		lvc.cx = 500;
		lvc.pszText = "URL";
		lvc.iSubItem = i;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_ITEM), i, &lvc);

		//Xgr[̃X^C̐ݒ
		SetWindowLong(GetDlgItem(hDlg, IDC_LIST_ITEM), GWL_STYLE,
			GetWindowLong(GetDlgItem(hDlg, IDC_LIST_ITEM), GWL_STYLE) | LVS_SHOWSELALWAYS);
		SendMessage(GetDlgItem(hDlg, IDC_LIST_ITEM), LVM_SETEXTENDEDLISTVIEWSTYLE, 0,
			LVS_EX_ONECLICKACTIVATE | LVS_EX_FULLROWSELECT |
			SendMessage(GetDlgItem(hDlg, IDC_LIST_ITEM), LVM_GETEXTENDEDLISTVIEWSTYLE, 0, 0));

		tpTreeInfo = (struct TPTREE *)TreeView_GetlParam(GetDlgItem(WWWCWnd, WWWC_TREE),
			TreeView_GetSelection(GetDlgItem(WWWCWnd, WWWC_TREE)));
		if(tpTreeInfo == NULL){
			EndDialog(hDlg, FALSE);
			return TRUE;
		}
		for(i = 0; i < tpTreeInfo->ItemListCnt; i++){
			tpItemInfo = *(tpTreeInfo->ItemList + i);
			if(tpItemInfo == NULL){
				continue;
			}
			index = SetListItem(GetDlgItem(hDlg, IDC_LIST_ITEM), tpItemInfo->Title, 0, (long)tpItemInfo, -1);
			if(tpItemInfo->CheckURL != NULL){
				ListView_SetItemText(GetDlgItem(hDlg, IDC_LIST_ITEM), index, 1, tpItemInfo->CheckURL);
			}
		}
		ListView_SetItemState(GetDlgItem(hDlg, IDC_LIST_ITEM), 0, LVIS_FOCUSED, LVIS_FOCUSED);
		break;

	case WM_DRAWITEM:
		//`悷t[Rg[X^Cݒ
		switch((UINT)wParam)
		{
		case IDC_BUTTON_UP:
			i = DFCS_SCROLLUP;
			break;

		case IDC_BUTTON_DOWN:
			i = DFCS_SCROLLDOWN;
			break;

		default:
			return FALSE;
		}
		//{^̕`
		DrawScrollControl((LPDRAWITEMSTRUCT)lParam, i);
		break;

	case WM_CLOSE:
		EndDialog(hDlg, FALSE);
		break;

	case WM_SIZE:
		break;

	case WM_SIZING:
		return FALSE;

	case WM_EXITSIZEMOVE:
		break;

	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDC_BUTTON_UP:
			if(ListView_GetSelectedCount(GetDlgItem(hDlg, IDC_LIST_ITEM)) <= 0){
				break;
			}
			if(ListView_GetNextItem(GetDlgItem(hDlg, IDC_LIST_ITEM), -1, LVIS_SELECTED) <= 0){
				break;
			}
			i = -1;
			while((i = ListView_GetNextItem(GetDlgItem(hDlg, IDC_LIST_ITEM), i, LVNI_SELECTED)) != -1){
				ListView_SetItemState(GetDlgItem(hDlg, IDC_LIST_ITEM), i, 0, LVIS_SELECTED);
				ListView_MoveItem(GetDlgItem(hDlg, IDC_LIST_ITEM), i, -1, 2);
				ListView_SetItemState(GetDlgItem(hDlg, IDC_LIST_ITEM), i - 1, LVIS_SELECTED, LVIS_SELECTED);
			}
			break;

		case IDC_BUTTON_DOWN:
			if(ListView_GetSelectedCount(GetDlgItem(hDlg, IDC_LIST_ITEM)) <= 0){
				break;
			}
			if(ListView_GetItemState(GetDlgItem(hDlg, IDC_LIST_ITEM),
				ListView_GetItemCount(GetDlgItem(hDlg, IDC_LIST_ITEM)) - 1, LVNI_SELECTED) == LVNI_SELECTED){
				break;
			}
			for(i = ListView_GetItemCount(GetDlgItem(hDlg, IDC_LIST_ITEM)) - 1; i >= 0; i--){
				if(ListView_GetItemState(GetDlgItem(hDlg, IDC_LIST_ITEM), i, LVNI_SELECTED) == LVNI_SELECTED){
					ListView_SetItemState(GetDlgItem(hDlg, IDC_LIST_ITEM), i, 0, LVIS_SELECTED);
					ListView_MoveItem(GetDlgItem(hDlg, IDC_LIST_ITEM), i, 1, 2);
					ListView_SetItemState(GetDlgItem(hDlg, IDC_LIST_ITEM), i + 1, LVIS_SELECTED, LVIS_SELECTED);
				}
			}
			break;

		case IDC_BUTTON_DELNUM:
			if(MessageBox(hDlg, "Rgɐݒ肳Ă鏇ԍ܂H", "ԍ̏", MB_ICONQUESTION | MB_YESNO) == IDNO){
				break;
			}
			cnt = ListView_GetItemCount(GetDlgItem(hDlg, IDC_LIST_ITEM));
			for(i = 0; i < cnt; i++){
				tpItemInfo = (struct TPITEM *)ListView_GetlParam(GetDlgItem(hDlg, IDC_LIST_ITEM), i);
				if(tpItemInfo != NULL && tpItemInfo->Comment != NULL){
					for(r = p = tpItemInfo->Comment; *p != '\0'; p++){
						if(*p == ':'){
							r = p + 1;
							break;
						}
						if(*p < '0' || *p > '9'){
							break;
						}
					}
					if(r != tpItemInfo->Comment){
						lstrcpy(tpItemInfo->Comment, r);
					}
				}
			}
			break;

		case IDOK:
			//Xgr[̕בւ
			hListView = GetDlgItem(WWWCWnd, WWWC_LIST);
			SendMessage(hListView, WM_SETREDRAW, (WPARAM)FALSE, 0);
			cnt = ListView_GetItemCount(hListView);
			for(i = 0, j = 0; i < cnt; i++){
				if((struct TPITEM *)ListView_GetlParam(hListView, i) == NULL){
					continue;
				}
				tpItemInfo = (struct TPITEM *)ListView_GetlParam(GetDlgItem(hDlg, IDC_LIST_ITEM), j);
				if(IsDlgButtonChecked(hDlg, IDC_CHECK_SETCOMMENT) == 1){
					wsprintf(buf, "%04d:", j + 1);
					if(tpItemInfo->Comment != NULL){
						for(r = p = tpItemInfo->Comment; *p != '\0'; p++){
							if(*p == ':'){
								r = p + 1;
								break;
							}
							if(*p < '0' || *p > '9'){
								break;
							}
						}
						cmt = (char *)GlobalAlloc(GMEM_FIXED, lstrlen(buf) + lstrlen(r) + 1);
						if(cmt != NULL){
							lstrcpy(cmt, buf);
							lstrcpy(cmt + lstrlen(buf), r);
						}
					}else{
						cmt = (char *)GlobalAlloc(GMEM_FIXED, lstrlen(buf) + 1);
						if(cmt != NULL){
							lstrcpy(cmt, buf);
						}
					}
					if(cmt != NULL){
						if(tpItemInfo->Comment != NULL) GlobalFree(tpItemInfo->Comment);
						tpItemInfo->Comment = (char *)GlobalAlloc(GMEM_FIXED, lstrlen(cmt) + 1);
						if(tpItemInfo->Comment != NULL){
							lstrcpy(tpItemInfo->Comment, cmt);
						}
						GlobalFree(cmt);
					}
				}
				ListView_SetlParam(hListView, i, (long)tpItemInfo);
				ListView_SetItemText(hListView, i, 0, LPSTR_TEXTCALLBACK);
				ListView_SetItemState(hListView, i,
					((tpItemInfo->CheckSt == 1) ? INDEXTOOVERLAYMASK(ICON_ST_NOCHECK) : 0), LVIS_OVERLAYMASK);
				ListView_RedrawItems(hListView, i, i);
				j++;
			}
			SendMessage(hListView, WM_SETREDRAW, (WPARAM)TRUE, 0);
			UpdateWindow(hListView);

			//Xgr[̕тŃACeݒ
			tpTreeInfo = (struct TPTREE *)TreeView_GetlParam(GetDlgItem(WWWCWnd, WWWC_TREE),
				TreeView_GetSelection(GetDlgItem(WWWCWnd, WWWC_TREE)));
			if(tpTreeInfo != NULL){
				GlobalFree(tpTreeInfo->ItemList);
				tpTreeInfo->ItemListCnt = 0;
				tpTreeInfo->ItemList = ListView_SetListToMem(hListView, &tpTreeInfo->ItemListCnt);
			}
			EndDialog(hDlg, TRUE);
			break;

		case IDCANCEL:
			EndDialog(hDlg, FALSE);
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}


/******************************************************************************

	SortItem

	C

******************************************************************************/

__declspec(dllexport) int CALLBACK SortItem(HWND hWnd, struct TPITEM **ToolItemList,
													  int ToolItemListCnt, int type, int CheckType)
{
	BOOL ret;

	if(ToolItemListCnt <= 0 || ToolItemList == NULL){
		//XgȂ
		return 0;
	}
	if(type != TOOL_EXEC_WINDOWMENU){
		return 0;
	}

	WWWCWnd = hWnd;

	ret = DialogBoxParam(g_hinst, MAKEINTRESOURCE(IDD_DIALOG_SETSORT), hWnd, ItemSortProc, 0);
	return ((ret == TRUE) ? 1 : 0);
}
/* End of source */
